<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta charset='UTF-8'>
    <meta name="author" content="Benjamin Verner">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="styles.css">
    <title>
    Pozorování
    </title>
  </head>
  <body>
    <ul>
      <li class="menu"><a href="index.html">Úvod</a></li>
      <li class="menu"><a href="solver.html">SAT Solver</a></li>
      <li class="submenu">
        <a class="submenu-button">Konkrétní problémy</a>
        <div class="submenu-elements">
          <a href="pozorovani.html">Pozorování</a>
          <a href="sudoku.html">Sudoku</a>
          <a href="abc.html">Easy as ABC</a>
          <a href="logik.html">Logik</a>
          <a href="slitherlink.html">Slitherlink</a>
        </div>
      </li>
      <li class="menu"><a href="dokumentace.html">Technická dokumentace</a></li>
      <li class="menu"><a href="zaver.html">Závěr</a></li>
       <li class="menu"><a href="citace.html">Citace</a></li>
    </ul>
    <article>
      <h2 id="title">Pozorování</h2>
      <section>
        <p>Rád bych nejprve začal pozorováním, které se bude hodit pro vytváření pravidel Logiku a Slitherlinku. Týká se to způsobu, jak zajistit, aby z množiny proměnných byl platný daný počet. Označme si tento počet jako K a velikost množiny jako N. Pak platí, že omezení zdola počtu proměnných s hodnotou 1 je kombinace všech N - K + 1 tic, a omezení shora je kombinace negací všech K + 1 tic.</p>
      </section>
      <section>
        <h4>K omezení zdola:</h4>
        <p>Kdybychom chtěli vybrat proměnných jen K - 1 (případně i méně), nutně by existovala klauzule, kde není ani jedna z vybraných proměnných (jsou to klausule N - (K - 1) tic), tudíž by nebyly splněné všechny klausule.</p>
      </section>
      <section>
        <h4>K omezení shora:</h4>
        <p>Kdybychom chtěli vybrat více než K proměnných, nutně by existovala klausule skládající se pouze z negací vybraných proměnných, takže by tato klausule nemohla platit.</p>
      </section>
      <section>
        <h4>Příklad pro K=3 a N=5:</h4>
        <table>
          <thead>
            <tr>
              <th>B D</th>
              <th>B C E</th>
              <th>A B C D</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td>
                <p>(A ∨ <span class="blue">B</span> ∨ C)</p>
                <p>(A ∨ <span class="blue">B</span> ∨ <span class="blue">D</span>)</p>
                <p>(A ∨ <span class="blue">B</span> ∨ E)</p>
                <p>(A ∨ C ∨ <span class="blue">D</span>)</p>
                <p class="red">(A ∨ C ∨ E)</p>
                <p>(A ∨ <span class="blue">D</span> ∨ E)</p>
                <p>(<span class="blue">B</span> ∨ C ∨ <span class="blue">D</span>)</p>
                <p>(<span class="blue">B</span> ∨ C ∨ E)</p>
                <p>(<span class="blue">B</span> ∨ <span class="blue">D</span> ∨ E)</p>
                <p>(C ∨ <span class="blue">D</span> ∨ E)</p>
                <p>(<span class="blue">¬A</span> ∨ ¬B ∨ <span class="blue">¬C</span> ∨ ¬D)</p>
                <p>(<span class="blue">¬A</span> ∨ ¬B ∨ <span class="blue">¬C</span> ∨ <span class="blue">¬E</span>)</p>
                <p>(<span class="blue">¬A</span> ∨ ¬B ∨ ¬D ∨ <span class="blue">¬E</span>)</p>
                <p>(<span class="blue">¬A</span> ∨ <span class="blue">¬C</span> ∨ ¬D ∨ <span class="blue">¬E</span>)</p>
                <p>(¬B ∨ <span class="blue">¬C</span> ∨ ¬D ∨ <span class="blue">¬E</span>)</p>
              </td>
              <td>
                <p>(A ∨ <span class="blue">B</span> ∨ <span class="blue">C</span>)</p>
                <p>(A ∨ <span class="blue">B</span> ∨ D)</p>
                <p>(A ∨ <span class="blue">B</span> ∨ <span class="blue">E</span>)</p>
                <p>(A ∨ <span class="blue">C</span> ∨ D)</p>
                <p>(A ∨ <span class="blue">C</span> ∨ <span class="blue">E</span>)</p>
                <p>(A ∨ D ∨ <span class="blue">E</span>)</p>
                <p>(<span class="blue">B</span> ∨ <span class="blue">C</span> ∨ D)</p>
                <p>(<span class="blue">B</span> ∨ <span class="blue">C</span> ∨ <span class="blue">E</span>)</p>
                <p>(<span class="blue">B</span> ∨ D ∨ <span class="blue">E</span>)</p>
                <p>(<span class="blue">C</span> ∨ D ∨ <span class="blue">E</span>)</p>
                <p>(<span class="blue">¬A</span> ∨ ¬B ∨ ¬C ∨ <span class="blue">¬D</span>)</p>
                <p>(<span class="blue">¬A</span> ∨ ¬B ∨ ¬C ∨ ¬E)</p>
                <p>(<span class="blue">¬A</span> ∨ ¬B ∨ <span class="blue">¬D</span> ∨ ¬E)</p>
                <p>(<span class="blue">¬A</span> ∨ ¬C ∨ <span class="blue">¬D</span> ∨ ¬E)</p>
                <p>(¬B ∨ ¬C ∨ <span class="blue">¬D</span> ∨ ¬E)</p>
              </td>
              <td>
                <p>(<span class="blue">A</span> ∨ <span class="blue">B</span> ∨ <span class="blue">C</span>)</p>
                <p>(<span class="blue">A</span> ∨ <span class="blue">B</span> ∨ <span class="blue">D</span>)</p>
                <p>(<span class="blue">A</span> ∨ <span class="blue">B</span> ∨ E)</p>
                <p>(<span class="blue">A</span> ∨ <span class="blue">C</span> ∨ <span class="blue">D</span>)</p>
                <p>(<span class="blue">A</span> ∨ <span class="blue">C</span> ∨ E)</p>
                <p>(<span class="blue">A</span> ∨ <span class="blue">D</span> ∨ E)</p>
                <p>(<span class="blue">B</span> ∨ <span class="blue">C</span> ∨ <span class="blue">D</span>)</p>
                <p>(<span class="blue">B</span> ∨ <span class="blue">C</span> ∨ E)</p>
                <p>(<span class="blue">B</span> ∨ <span class="blue">D</span> ∨ E)</p>
                <p>(<span class="blue">C</span> ∨ <span class="blue">D</span> ∨ E)</p>
                <p class="red">(¬A ∨ ¬B ∨ ¬C ∨ ¬D)</p>
                <p>(¬A ∨ ¬B ∨ ¬C ∨ <span class="blue">¬E</span>)</p>
                <p>(¬A ∨ ¬B ∨ ¬D ∨ <span class="blue">¬E</span>)</p>
                <p>(¬A ∨ ¬C ∨ ¬D ∨ <span class="blue">¬E</span>)</p>
                <p>(¬B ∨ ¬C ∨ ¬D ∨ <span class="blue">¬E</span>)</p>
              </td>
            </tr>
            <tr>
              <td>→ moc málo proměnných</td>
              <td rowspan="2">→ kombinace 3 proměnných splňuje klauzule</td>
              <td>→ příliš mnoho proměnných</td>
            </tr>
            <tr>
              <td>→ nesplněno (A ∨ C ∨ E)</td>
              <td>→ nesplněno (¬A ∨ ¬B ∨ ¬C ∨ ¬D)</td>
            </tr>
          </tbody>
        </table>
      </section>
    </article>
  </body>
</html>
